## samba 4.10.7+dfsg

=== debian/changelog ===
samba (2:4.10.7+dfsg-0ubuntu2) eoan; urgency=medium

  * SECURITY UPDATE: restricted share escape by user (LP: #1842533)
    - debian/patches/CVE-2019-10197-01-v4-10.patch: smbd: separate
      out impersonation debug info into a new function.
    - debian/patches/CVE-2019-10197-02-v4-10.patch: smbd: make sure that
      change_to_user_internal() always resets current_user.done_chdir
    - debian/patches/CVE-2019-10197-03-v4-10.patch: smbd: make sure we
      reset current_user.{need,done}_chdir in become_root()
    - debian/patches/CVE-2019-10197-04-v4-10.patch: selftest: make
      fsrvp_share its own independent subdirectory
    - debian/patches/CVE-2019-10197-05-v4-10.patch:
      test_smbclient_s3.sh: add regression test for the no permission
      on share root problem
    - debian/patches/CVE-2019-10197-06-v4-10.patch: smbd: split
      change_to_user_impersonate() out of change_to_user_internal()
    - CVE-2019-10197

 -- Steve Beattie <sbeattie@ubuntu.com>  Fri, 30 Aug 2019 11:07:19 -0700

samba (2:4.10.7+dfsg-0ubuntu1) eoan; urgency=medium

  * New upstream version: 4.10.7
    - d/p/ctdb-config-depend-on-etc-default-nodes-file.patch: dropped,
      included upstream in 4.10.7

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 22 Aug 2019 15:03:23 -0300

samba (2:4.10.6+dfsg-0ubuntu1) eoan; urgency=medium

  * New upstream version: 4.10.6
    - d/p/fix-nfs-service-name-to-nfs-kernel-server.patch: changed to update
      the Debian config and use it.
    - d/control: update ldb build-deps to 1.5.5
  * Dropped:
    - d/p/CVE-2019-12436.patch: fixed upstream in 4.10.5
    - d/p/CVE-2019-12435-*.patch: fixed upstream in 4.10.5
    - d/p/CVE-2018-16860-*.patch: fixed upstream in 4.10.3
    - d/p/CVE-2019-3880.patch: fixed upstream in 4.10.2
    - d/p/CVE-2019-3870-*.patch: fixed upstream in 4.10.2
    - d/p/dlz_bind_zone_update.patch: fixed upstream in 4.10.1
    - d/p/ctdb-scripts-fix-tcp_tw_recycle-existence-check.patch: fixed
      upstream in 4.10.5

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 07 Aug 2019 17:20:48 -0300

samba (2:4.10.0+dfsg-0ubuntu6) eoan; urgency=medium

  * d/p/fix-nfs-service-name-to-nfs-kernel-server.patch:
    change service name from nfs to nfs-kernel-server in
    legacy script 06.nfs.script also (LP: #722201)

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Thu, 11 Jul 2019 21:44:49 +0000

samba (2:4.10.0+dfsg-0ubuntu5) eoan; urgency=medium

  * debian/rules: Make DEB_HOST_ARCH_CPU initialized through
    dpkg-architecture (Closes: #931138)
  * d/p/ctdb-scripts-fix-tcp_tw_recycle-existence-check.patch:
    fix tcp_tw_recycle existence check. (LP: #722201)
  * d/p/fix-nfs-service-name-to-nfs-kernel-server.patch:
    change nfs service name from nfs to nfs-kernel-server
    (LP: #722201)
  * d/ctdb.install, d/rules: create ctdb run directory into tmpfiles.d
    to allow pid file to exist (LP: #1821775)
  * Allow proper ctdb initialization (LP: #1828799):
    - d/ctdb.dirs: added /var/lib/ctdb/* directories
    - d/ctdb.postrm: remove leftovers from:
      /var/lib/ctdb/{state,persistent,volatile,scripts}
  * d/rules: installing provided config examples and helper scripts
  * Examples of NFS HA CTDB config files + helper script:
    - d/ctdb.example.enable.nfs.sh
    - d/ctdb.example.nfs-common
    - d/ctdb.example.nfs-kernel-server
    - d/ctdb.example.services
    - d/ctdb.example.sysctl-nfs-static-ports.conf
  * d/p/ctdb-config-depend-on-etc-default-nodes-file.patch:
    do not try to start daemon if /etc/ctdb/nodes does not exist
  * d/p/ctdb-config-enable-syslog-by-default.patch:
    enable syslog and systemd journal by default

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Fri, 28 Jun 2019 00:14:27 +0000

samba (2:4.10.0+dfsg-0ubuntu4) eoan; urgency=medium

  * SECURITY UPDATE: zone operations can crash rpc server
    - debian/patches/CVE-2019-12435-1.patch: avoid NULL deference if zone
      not found in DnssrvOperation in
      python/samba/tests/dcerpc/dnsserver.py,
      source4/rpc_server/dnsserver/dcerpc_dnsserver.c.
    - debian/patches/CVE-2019-12435-2.patch: avoid NULL deference if zone
      not found in DnssrvOperation2 in
      python/samba/tests/dcerpc/dnsserver.py,
      source4/rpc_server/dnsserver/dcerpc_dnsserver.c.
    - CVE-2019-12435
  * SECURITY UPDATE: paged_searches crash on LDAP and homes access
    - debian/patches/CVE-2019-12436.patch: ignore successful results
      without messages in source4/dsdb/samdb/ldb_modules/paged_results.c,
      source4/dsdb/tests/python/vlv.py.
    - CVE-2019-12436

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Jun 2019 10:08:44 -0400

samba (2:4.10.0+dfsg-0ubuntu3) eoan; urgency=medium

  * SECURITY UPDATE: Samba AD DC S4U2Self/S4U2Proxy unkeyed checksum
    - debian/patches/CVE-2018-16860-1.patch: add test for S4U2Self with
      unkeyed checksum in selftest/knownfail.d/mitm-s4u2self,
      source4/torture/krb5/kdc-canon-heimdal.c.
    - debian/patches/CVE-2018-16860-2.patch: reject PA-S4U2Self with
      unkeyed checksum in selftest/knownfail.d/mitm-s4u2self,
      source4/heimdal/kdc/krb5tgs.c.
    - CVE-2018-16860

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 14 May 2019 09:10:24 -0400

=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Jelmer Vernooĳ <jelmer@debian.org>,
           Ivo De Decker <ivodd@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Andrew Bartlett <abartlet+debian@catalyst.net.nz>
Homepage: http://www.samba.org
Standards-Version: 4.2.1
Build-Depends: bison,
               debhelper (>= 11),
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               flex,
               libacl1-dev,
               libarchive-dev,
               libattr1-dev,
               libavahi-client-dev,
               libavahi-common-dev,
               libblkid-dev,
               libbsd-dev,
               libcap-dev [linux-any],
               libcephfs-dev [linux-any],
               libcmocka-dev (>= 1.1.3),
               libcups2-dev,
               libdbus-1-dev,
               libgnutls28-dev,
               libgpgme11-dev,
               libjansson-dev,
               libldap2-dev,
               libldb-dev (>= 2:1.5.5),
               libncurses5-dev,
               libpam0g-dev,
               libparse-yapp-perl,
               libpcap-dev [hurd-i386 kfreebsd-any],
               libpopt-dev,
               libreadline-dev,
               libsystemd-dev [linux-any],
               libtalloc-dev (>= 2.1.15~),
               libtdb-dev (>= 1.3.17~),
               libtevent-dev (>= 0.9.38~),
               perl,
               pkg-config,
               po-debconf,
               python3-all-dev,
               python3-dnspython,
               python3-ldb (>= 2:1.5.5),
               python3-ldb-dev (>= 2:1.5.5),
               python3-talloc-dev (>= 2.1.15~),
               python3-tdb (>= 1.3.17~),
               python3-testtools,
               python3,
               xfslibs-dev [linux-any],
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: adduser,
         libpam-modules,
         libpam-runtime (>= 1.0.1-11),
         lsb-base (>= 4.1+Debian),
         procps,
         python3,
         python3-dnspython,
         python3-samba,
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         tdb-tools,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: attr, logrotate, samba-dsdb-modules, samba-vfs-modules
Suggests: bind9 (>= 1:9.5.1),
          bind9utils,
          ctdb,
          ldb-tools,
          ntp | chrony (>= 3.0-1),
          smbldap-tools,
          ufw,
          winbind
Enhances: bind9, ntp
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an NT4-style domain controller, and can integrate with both NT4 domains
 and Active Directory realms as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 or Active Directory domain controller.
 For use in an NT4 domain or Active Directory realm, you will also need the
 winbind package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: samba (<< 2:4.3.3+dfsg-1)
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: python3,
         python3-samba,
         samba-common (=${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: heimdal-clients
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.15.6~)
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Multi-Arch: same
Depends: libparse-yapp-perl, ${misc:Depends}, ${perl:Depends}
Recommends: samba-dev
Suggests: libwireshark-dev
Section: perl
Description: IDL compiler written in Perl
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev,
         libparse-pidl-perl,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev (>= 1.2.11),
         libtevent-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: python3-samba
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Provides: ${python3:Provides}
Depends: python3-crypto,
         python3-ldb,
         python3-tdb,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python 3 bindings for Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains Python 3 bindings for most Samba libraries.

Package: samba-dsdb-modules
Architecture: any
Multi-Arch: same
Section: libs
Depends: libgpgme11,
         samba-libs (= ${binary:Version}),
         ${ldb:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: libldb1
Description: Samba Directory Services Database
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains LDB plugins which add support for various Active
 Directory features to the LDB library.

Package: samba-vfs-modules
Architecture: any
Multi-Arch: same
Breaks: samba (<< 2:4.3.2+dfsg-1), samba-libs (<< 2:4.3.2+dfsg-1)
Replaces: samba (<< 2:4.3.2+dfsg-1), samba-libs (<< 2:4.3.2+dfsg-1)
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: ${vfsmods:Recommends}
Enhances: samba
Description: Samba Virtual FileSystem plugins
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 Virtual FileSystem modules are stacked shared libraries extending the
 functionality of Samba. Some examples are:
  * vfs_acl_xattr: Save NTFS-ACLs in Extended Attributes
  * vfs_audit: record selected Samba VFS operations in the system log
  * vfs_readonly: Make a Samba share read only for a specified time period
  * vfs_recycle: Give the same effect as the Recycle Bin on Windows computers
  * vfs_shadow_copy2: Expose snapshots to Windows clients as shadow copies
  * vfs_worm: Disallow writes for older file
 .
 Note: The runtime dependencies of vfs_ceph and vfs_snapper are moved to
 Recommends.

Package: libsmbclient
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

LDB_VERSION = $(shell pkg-config --modversion ldb)
LDB_EPOCH = $(shell dpkg-query -f '$${Version}' -W libldb-dev | sed 's/:.*//')
LDB_NEXT_VERSION = $(shell python3 -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print('.'.join(x))")
# samba ships ldb modules, which are specific to the ldb version, so we need a
# strict dependency on the upstream ldb version
# this also mean samba needs a rebuild when the upstream ldb version changes
LDB_DEPENDS = "libldb1 (<< $(LDB_EPOCH):$(LDB_NEXT_VERSION)~), libldb1 (>> $(LDB_EPOCH):$(LDB_VERSION)~)"
export PYSHORT=python3
export PYTHON=$(shell which $(PYSHORT))
export PYTHON_CONFIG="$(PYTHON)-config"
WAF = $(PYTHON) ./buildtools/bin/waf -v

# wrapper around cups-config, to work around #726726
export PATH:=$(CURDIR)/debian/bin:$(PATH)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

conf_args = \
		--prefix=/usr \
		--enable-fhs \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--libexecdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-privatedir=/var/lib/samba/private \
		--with-smbpasswd-file=/etc/samba/smbpasswd \
		--with-piddir=/var/run/samba \
		--with-pammodulesdir=/lib/$(DEB_HOST_MULTIARCH)/security \
		--with-pam \
		--with-syslog \
		--with-utmp \
		--with-winbind \
		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4 \
		--with-automount \
		--with-ldap \
		--with-ads \
		--with-dnsupdate \
		--with-gpgme \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba \
		--datadir=/usr/share \
		--with-lockdir=/var/run/samba \
		--with-statedir=/var/lib/samba \
		--with-cachedir=/var/cache/samba \
		--enable-avahi \
		--disable-rpath \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser,roken,replace,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
		--builtin-libraries=ccan,samba-cluster-support \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--with-cluster-support \
		--with-socketpath=/var/run/ctdb/ctdbd.socket \
		--with-logdir=/var/log/ctdb

ifeq ($(DEB_HOST_ARCH_OS), linux)
	conf_args += \
		--with-systemd \
		--systemd-install-services \
		--with-systemddir=/lib/systemd/system
else
	conf_args += \
		--without-systemd
endif

ifeq ($(DEB_HOST_ARCH_CPU), amd64)
	conf_args += \
		--accel-aes=intelaesni
endif

%:
	dh $* --with python3

override_dh_auto_configure:
	$(WAF) configure $(conf_args)

override_dh_auto_build:
	DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install
	# get list of files in build log
	find ${DESTDIR}
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.*
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already documented in debian/copyright
	-rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	# pam stuff
	mkdir -p $(DESTDIR)/usr/share/pam-configs
	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	# we don't ship the symlinks
	rm $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libnss_*.so
	#Remove unused vfstest manpage vfstest is no longer installed
	rm $(DESTDIR)/usr/share/man/man1/vfstest.1
	# Debian goodies to set global option in smb.conf and add a share
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	# Debian goodies
	cp debian/smb.conf* $(DESTDIR)/usr/share/samba/
	install -m755 debian/panic-action $(DESTDIR)/usr/share/samba/panic-action
	cp debian/gdbcommands $(DESTDIR)/etc/samba/
	mkdir -p $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d
	install -m755 debian/samba-common.dhcp $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d/samba
	# Ubuntu things
	mkdir -p $(DESTDIR)/usr/share/apport/package-hooks
	install -D -m 644 debian/source_samba.py $(DESTDIR)/usr/share/apport/package-hooks/source_samba.py
	install -m 0755 debian/mksmbpasswd.awk $(DESTDIR)/usr/sbin/mksmbpasswd
	mkdir -p $(DESTDIR)/etc/ufw/applications.d
	install -m644 debian/samba.ufw.profile $(DESTDIR)/etc/ufw/applications.d/samba
	# Install other stuff not installed by "make install"
	# This moves the dckeytab module to the samba package in order to avoid
	# a circular dependency between python3-samba, samba and samba-common-bin
	mkdir -p debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba
	mv $(DESTDIR)/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab*.so \
	   debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba/
	# use upstream version of smb.conf.5 if there is no built version
	# this is a temporary workaround for #750593 in xsltproc
	[ -e $(DESTDIR)/usr/share/man/man5/smb.conf.5 ] || \
	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
	# Tests that shouldn't be installed
	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
	# Remove ctdb tests
	rm $(DESTDIR)/usr/bin/ctdb_run_tests
	rm $(DESTDIR)/usr/bin/ctdb_run_cluster_tests
	rm -r $(DESTDIR)/usr/lib/*/ctdb/tests
	rm -r $(DESTDIR)/usr/share/ctdb/tests
ifeq ($(DEB_HOST_ARCH_OS), linux)
	# Install systemd configs
	mkdir -p $(DESTDIR)/lib/systemd/system/
	install -m 0644 ctdb/config/ctdb.service $(DESTDIR)/lib/systemd/system/
	# Services fixups
	mv $(DESTDIR)/lib/systemd/system/nmb.service $(DESTDIR)/lib/systemd/system/nmbd.service
	mv $(DESTDIR)/lib/systemd/system/smb.service $(DESTDIR)/lib/systemd/system/smbd.service
	mv $(DESTDIR)/lib/systemd/system/samba.service $(DESTDIR)/lib/systemd/system/samba-ad-dc.service
	sed -i \
	  -e 's|/etc/sysconfig/|/etc/default/|' \
	  -e 's|nmb\.service|nmbd.service|' \
	  -e 's|smb\.service|smbd.service|' \
	  -e 's|samba\.service|samba-ad-dc.service|' \
	  $(DESTDIR)/lib/systemd/system/nmbd.service \
	  $(DESTDIR)/lib/systemd/system/samba-ad-dc.service \
	  $(DESTDIR)/lib/systemd/system/smbd.service \
	  $(DESTDIR)/lib/systemd/system/winbind.service
endif
	# Harmless on systems without systemd-tmpfiles, and other consumers exist
	# such as OpenRC's opentmpfiles
	mkdir -p $(DESTDIR)/usr/lib/tmpfiles.d
	echo "d /run/samba 0755 root root -" > $(DESTDIR)/usr/lib/tmpfiles.d/samba.conf
	echo "d /run/ctdb 0755 root root -" > $(DESTDIR)/usr/lib/tmpfiles.d/ctdb.conf

override_dh_installdocs-arch:
	cp ctdb/config/events/README ctdb/README.eventscripts
	cp ctdb/config/notification.README ctdb/README.notification
	dh_installdocs
ifeq ($(DEB_HOST_ARCH_OS), hurd)
	dh_installdocs -pctdb debian/ctdb.README.hurd
endif
ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	dh_installdocs -pctdb debian/ctdb.README.kfreebsd
endif

override_dh_installexamples-arch:
	# CTDB config examples and helper scripts
	mkdir -p ctdb/doc/examples/nfs-kernel-server
	cp debian/ctdb.example.enable.nfs.sh ctdb/doc/examples/nfs-kernel-server/enable-nfs.sh
	cp debian/ctdb.example.nfs-common ctdb/doc/examples/nfs-kernel-server/nfs-common
	cp debian/ctdb.example.nfs-kernel-server ctdb/doc/examples/nfs-kernel-server/nfs-kernel-server

## samba 4.11.5%2Bdfsg

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

import sys
import os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist
from waflib import Options, Utils, Logs, Context

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('port.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h alloca.h float.h')

    conf.SET_TARGET_TYPE('tirpc', 'EMPTY')

    if conf.CHECK_CODE(
            '\n#ifndef _TIRPC_RPC_H\n#error "no tirpc headers in system path"\n#endif\n',
            'HAVE_RPC_RPC_HEADERS',
            headers=['rpc/rpc.h', 'rpc/nettype.h'],
            msg='Checking for tirpc rpc headers in default system path'):
        if conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            conf.undefine('HAVE_RPC_RPC_H')

    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libtirpc', args='--cflags --libs',
                       msg='Checking for libtirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libntirpc', args='--cflags',
                       msg='Checking for libntirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            Logs.warn('No rpc/rpc.h header found, tirpc or libntirpc missing?')

    conf.SET_TARGET_TYPE('nsl', 'EMPTY')
    conf.CHECK_HEADERS('rpc/rpc.h rpcsvc/yp_prot.h', lib='tirpc')
    if not conf.CONFIG_SET('HAVE_RPCSVC_YP_PROT_H'):
        if conf.CHECK_CFG(package='libnsl', args='--cflags --libs',
                          msg='Checking for libnsl',
                          uselib_store='NSL'):
            conf.SET_TARGET_TYPE('nsl', 'SYSLIB')
            conf.CHECK_HEADERS('rpc/rpc.h rpcsvc/yp_prot.h', lib='tirpc nsl')
        else:
            conf.SET_TARGET_TYPE('nsl', 'SYSLIB')
    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h', lib='tirpc nsl')

    conf.CHECK_HEADERS('sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h')
    conf.CHECK_HEADERS('valgrind/memcheck.h valgrind/helgrind.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h stdatomic.h')
    conf.CHECK_HEADERS('libgen.h')

    if conf.CHECK_CFLAGS('-Wno-format-truncation'):
        conf.define('HAVE_WNO_FORMAT_TRUNCATION', '1')

    if conf.CHECK_CFLAGS('-Wno-unused-function'):
        conf.define('HAVE_WNO_UNUSED_FUNCTION', '1')

    if conf.CHECK_CFLAGS('-Wno-strict-overflow'):
        conf.define('HAVE_WNO_STRICT_OVERFLOW', '1')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    # Those functions are normally available in libc
    if not conf.CHECK_FUNCS('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h'):
        conf.CHECK_FUNCS_IN('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            'socket nsl',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')
        conf.DEFINE('REPLACE_REQUIRES_LIBSOCKET_LIBNSL', 1)

    conf.CHECK_FUNCS('memset_s memset_explicit')

    conf.CHECK_CODE('''
                    #include <string.h>

                    int main(void)
                    {
                        char buf[] = "This is some content";
                        memset(buf, '\0', sizeof(buf)); __asm__ volatile("" : : "g"(&buf) : "memory");
                        return 0;
                    }
                    ''',
                    define='HAVE_GCC_VOLATILE_MEMORY_PROTECTION',
                    addmain=False,
                    msg='Checking for volatile memory protection',
                    local_include=False)

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
